<?php
namespace Geral\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;

/**
 * @method \Geral\Repositories\Endefili getRepository static
 */
class Endefili extends Base\Endefili
{
    public static function insere($nrorg, $cdfilial, $idtpendefili, $cdpais,
        $sgestado, $cdmunicipio)
    {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $endereco = new Endefili();
            $endereco->setNrorg($nrorg);
            $endereco->setNrorginclusao($nrorg);
            $endereco->setNrorgultatu($nrorg);
            $endereco->setDtinclusao(DateUtil::getDataAtual());
            $endereco->setDtultatu(DateUtil::getDataAtual());
            $endereco->setCdoperinclusao(Ambiente::getCdoperador());
            $endereco->setCdoperultatu(Ambiente::getCdoperador());
            $endereco->setCdfilial($cdfilial);
            $endereco->setIdtpendefili($idtpendefili);
            $endereco->setCdpais($cdpais);
            $endereco->setSgestado($sgestado);
            $endereco->setCdmunicipio($cdmunicipio);
            $endereco->setIdutsslemail('N');
            $endereco->setIduttlsemail('N');
            $endereco->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function atualiza($nrorg, $cdfilial, $cdpais, $sgestado,
        $cdmunicipio)
    {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $endereco = Endefili::getObjectByWhere(
                'CDFILIAL = ? AND NRORG = ?',
                array($cdfilial, $nrorg)
            );
            if ($endereco instanceof Endefili) {
                $endereco->setNrorgultatu($nrorg);
                $endereco->setDtultatu(DateUtil::getDataAtual());
                $endereco->setCdoperultatu(Ambiente::getCdoperador());
                $endereco->setCdpais($cdpais);
                $endereco->setSgestado($sgestado);
                $endereco->setCdmunicipio($cdmunicipio);
                $endereco->persist();
                $connection->flush();
                $connection->commit();
            }
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}