/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FOPE                                                     */
/* Tabela : FILIOPER                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FOPE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FOPE
GO

CREATE TRIGGER DTULTATU_FOPE
ON FILIOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FILIOPER', CDFILIAL, 'CDOPERADOR=' + CDOPERADOR + ';' +
                                             'CDFILIAL='   + CDFILIAL   + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FILIOPER
      SET DTULTATUFOPE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(FILIOPER.CDOPERADOR,0)  = ISNULL(INSERTED.CDOPERADOR,0)) AND
            (ISNULL(FILIOPER.CDFILIAL,0)    = ISNULL(INSERTED.CDFILIAL,0));
            
      UPDATE OPERADOR
      SET DTULTATUOPER = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(OPERADOR.CDOPERADOR,0)  = ISNULL(INSERTED.CDOPERADOR,0)) ;
      
   END;
END;
GO

UPDATE FILIOPER SET DTULTATUFOPE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUFOPE IS NULL
GO



IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUFOPE' and
            type = 'D')
   ALTER TABLE FILIOPER DROP CONSTRAINT DEFAULT_DTULTATUFOPE
GO

ALTER TABLE FILIOPER ADD CONSTRAINT DEFAULT_DTULTATUFOPE
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUFOPE
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_FOPE','4.11.194';
GO

