#!/bin/sh

SCRIPTS_PATH=$('pwd')
PRODUCT_PATH=$('pwd')/../
PACKAGE_VERSION=1.74.0

export NPM_TOKEN="76f8066c-539b-47b8-8a76-4af6ceb8c20f"

echo 'Back step -------------------------------------------------------'
cd $PRODUCT_PATH/backend
{ # try
    $SCRIPTS_PATH/back_step.sh
} || { # catch
	echo 'Back Step Error ------------------------------------------------------'
    exit 1
}

echo 'Front step ------------------------------------------------------'
cd $PRODUCT_PATH/mobile
{ # try
	$SCRIPTS_PATH/front_step.sh 
} || { # catch
	echo 'Front Step Error ------------------------------------------------------'
    exit 1
}

$SCRIPTS_PATH/replace.sh "<>VUE_APP_META_CONTENT_SECURITY_POLICY<>" "Content-Security-Policy" ".env.production"
$SCRIPTS_PATH/replace.sh "<>VUE_APP_UPGRADE_INSECURE_REQUESTS<>" "upgrade-insecure-requests" ".env.production"

cd $PRODUCT_PATH/mobile/src/config
$SCRIPTS_PATH/replace.sh "<>SESSION_TIME<>" "3600000" "prodEnvironment.json"
$SCRIPTS_PATH/replace.sh "<>MODULES_THEME_COLOR<>" "#31758F" "prodEnvironment.json"

echo 'Grunt'
cd $PRODUCT_PATH/mobile
#$SCRIPTS_PATH/replace.sh "661" "1581" "package.json"
npm run translate
grunt backendStep
grunt reportTranslate
grunt buildEnvironment:production

#LISTA_LINGUAS=('en_us.json' 'es_cl.json' 'pt_br.json')
#for i in "${!LISTA_LINGUAS[@]}";
#do
#    tamanho=$(wc -c $(pwd)/assets/json/words/${LISTA_LINGUAS[$i]} | awk '{print $1}')
#    if [ $tamanho -lt 100 ]; then
#         echo ${LISTA_LINGUAS[$i]}
#         echo "Erro no Processo de Traducao. Arquivos Vazios"
#         exit 1
#    fi
#done

echo 'Update Package Version'
cd $PRODUCT_PATH
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "productInfo.json"
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "mobile/src/App.vue"
$SCRIPTS_PATH/replace.sh "0.1.0" $PACKAGE_VERSION "mobile/package.json"

echo 'Build'
{ # try
	cd $PRODUCT_PATH/mobile
	npm run build
} || { # catch
echo 'Run Build Error ------------------------------------------------------'
    exit 1
}

echo 'Move json'
mv -v ./assets/json ./dist/assets/json

echo 'Remove development dependencies'
cd $PRODUCT_PATH
rm -Rf README.md
rm -Rf mobile/package-lock.json
rm -Rf backend/.gitignore
rm -Rf backend/reports/connection.js.template
rm -Rf backend/parameters
rm -Rf backend/config/parameters.xml.template
rm -Rf backend/config/report.xml.template
