import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import { Icons } from '@zeedhi/common';
import { dayjs as moment, Messages, I18n } from '@zeedhi/core';
import TekLibComponents from '@zeedhi/tek-lib';
import { ZdRichText } from '@zeedhi/zd-richtext';

import '@fortawesome/fontawesome-free/css/all.css';
import { mdiApplicationCog, mdiCurrencyUsdCircleOutline } from '@mdi/js';
import router from '../router';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';
import '../styles/style.scss';
import '../controllers/utilities/MaskController';
import messages from '../../assets/json/messages.json';
import es_cl from '../../assets/json/words/es_cl.json';
import es_co from '../../assets/json/words/es_co.json';
import es_es from '../../assets/json/words/es_es.json';
import en_us from '../../assets/json/words/en_us.json';

Vue.component('ZdRichText', ZdRichText);

Icons.addIcons({
  dragHandle: 'mdi-drag-vertical',
  applicationCog: mdiApplicationCog,
  usdCircleOutline: mdiCurrencyUsdCircleOutline,
});

Vue.use(Zeedhi, {
  controllers,
  router,
  config,
});
Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);
Vue.use(TekLibComponents);

vuetify.framework.icons.values = Icons.getIcons() as any;

Messages.add({
  'pt-BR': {
    translation: {
      ...messages,
    },
  },
  'es-CL': {
    translation: {
      ...es_cl,
    },
  },
  'es-CO': {
    translation: {
      ...es_co,
    },
  },
  'es-ES': {
    translation: {
      ...es_es,
    },
  },
  'en-US': {
    translation: {
      ...en_us,
    },
  },
});

moment.locale(I18n.instance.language);
// moment.extend(localeData);
// moment.extend(localizedFormat);
